/***************************************************************************
                          FLInterface.h  -  description
                             -------------------
    begin                : Mon Jun 10 2002
    copyright            : (C) 2002 by Federico Albujer Zornoza
    email                : mail@infosial.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef FLINTERFACE_H
#define FLINTERFACE_H

#include <qstring.h>
#include <qobject.h>

class FLReceiver;

/** Interfase para los procesos de los formularios.

    @author Federico Albujer Zornoza.  */
class FLInterface
{
    public:
	
    /** constructor */
    FLInterface();

    /** destructor */
	~FLInterface();

    /** Para obtener el objeto encargado de la parte de proceso de un
        formulario.

        @param  n   Nombre de la tabla asociada al formulario.
        @return Objeto FLReceiver encargado de manejar la parte de proceso
                del formulario. */
    static FLReceiver *getReceiver(const QString &n);
};
#endif
