/***************************************************************************
                          FLSequece.h  -  description
                             -------------------
    begin                : thu sep 25 2002
    copyright            : (C) 2002 Ral Alexis Betancort Santana 
    email                : rabs@dimension-virtual.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef FLSEQUENCE_H
#define FLSEQUENCE_H

#include <qstring.h>
#include <FLSqlCursor.h>

/** Representa una secuencia consecutiva de nmeros.

    Esta clase sirve para crear secuencias consecutivas 
	 de nmeros, ltiles para numerar *documentos*

    @author Ral Alexis Betancort Santana
    @version 0.3 */
class FLSequence
{

    public:

    /** constructor.

        @param  table Nombre de la tabla donde est la secuencia
        @param  seqName Nombre de la secuencia*/
    FLSequence( const QString table, const QString seqName );

    /** destructor */
    ~FLSequence();

	 void setSeqName(QString name);

	 void setTable(QString table);

	 int nextID();

    private:

    /** Nivel de agrupamiento */
    QString table_;

    /** Nombre de la secuencia */
    QString seqName_;
};

#endif
